# CVS ID : $Id: ex1.tcl,v 1.2 2010/06/08 15:50:01 wuthrich Exp $
# --------------------------------------------------
#
# Example of a cyclic voltammetry experiment
#
# (c) Rolf Wuthrich
#     2010 Concordia University
#
# author:  Rolf Wuthrich
# email:   wuthrich@encs.concordia.ca
# version: v1 ($Revision: 1.2 $)
#
# --------------------------------------------------


# clears the memory
clear

# set aquisition and graph update times
set ::ectk::aquisitionUpdateInterval 0.2
set ::ectk::graphUpdateInterval 1

# chooses the plot style
plotStyle "with dots"
plotVars E I

# turns cell on
cell -on

# a CV experiment
# The electrode is polarised during 5 sec a -0.5 Volts 
# before starting the actual CV 
cv -einitial -0.5 -efinal 1.8 -scanrate 0.10 -ncycles 2 \
   -preProcess {IOdevice -write $::ectk::chanCtrl -0.5; wait 5} \
   -postProcess {cons "Terminated after $t sec."}

# turns cell off
cell -off
