# CVS ID : $Id: ex3.tcl,v 1.4 2011/07/09 15:15:01 wuthrich Exp $
# --------------------------------------------------
#
# Example of a user defined procedure
#
# (c) Rolf Wuthrich
#     2010 Concordia University
#
# author:  Rolf Wuthrich
# email:   wuthrich@encs.concordia.ca
# version: v1 ($Revision: 1.4 $)
#
# --------------------------------------------------

# clears the memory
clear

# defines the user procedure
proc myUserProc {} {
    global t
    return [expr 0.1*$t]
} 

# turns cell on
cell -on

# defines a user ECProcedure
# note that a trigger is needed in order to stop it
trigger -triggerScript {if {$t>2} {return STOP} else {return CONTINUE}} \
        -action {terminate $myproc}

set myproc [userproc -userScript myUserProc \
		     -preProcess {cons "Starting $::ectk::procList($ID)..."} \
                     -postProcess {cons "Finished"; userproc$ID -plot}]

# turns cell off
cell -off
