# CVS ID : $Id: ex4.tcl,v 1.3 2011/07/09 15:15:01 wuthrich Exp $
# --------------------------------------------------
#
# Example for testing speed of ECTk
#
# (c) Rolf Wuthrich
#     2010 Concordia University
#
# author:  Rolf Wuthrich
# email:   wuthrich@encs.concordia.ca
# version: v1 ($Revision: 1.3 $)
#
# --------------------------------------------------


# set aquisition and update times
set ::ectk::aquisitionUpdateInterval 0.01
set ::ectk::graphUpdateInterval 1

# clears the memory
clear

# defines the user procedure
proc myUserProc {} {
    global out
    set out [expr $out*(-1)]
    return $out
} 

global out
set out 1

# turns cell on
cell -on

# defines a user ECprocedure
# note that a trigger is needed in order to stop it

trigger -triggerScript {if {$t>20} {return STOP} else {return CONTINUE}} \
        -action {terminate $myproc}

set myproc [userproc -userScript myUserProc]

# turns cell off
cell -off


