# CVS ID : $Id: ex5.tcl,v 1.2 2010/12/05 20:14:48 wuthrich Exp $
# --------------------------------------------------
#
# Example of an experiment measuring a steady state polarisation curve
#
# Stores the results in notes
#
# (c) Rolf Wuthrich
#     2010 Concordia University
#
# author:  Rolf Wuthrich
# email:   wuthrich@encs.concordia.ca
# version: v1 ($Revision: 1.2 $)
#
# --------------------------------------------------

# clears memory
clear
notes -clear

# defines the name of the experiment
set ::ectk::expName Nickel

# adds a note
set d 1.5
notes -add {---------------------------}
notes -add {Working electrode:}
notes -add { - Nickel plate}
notes -add { - Diameter = $::d mm}
notes -add { - Surface  = [expr {3.14*$::d*$::d/4}] mm^2}
notes -add {}
notes -add {Counter electrode:}
notes -add { - Platinum wire}
notes -add {}
notes -add {Supporting electrolyte:}
notes -add { - NaOH 1M}
notes -add {---------------------------}
notes -add {Polarisation curve:}
notes -add {I\tE}

# Switch on the cell
cell -on

# Defines a succession of steps
for {set J 0.1} {$J<1} {set J [expr $J+0.1]} {
    step -stepValue $J \
	 -stepDuration 1 \
	 -postProcess {step$ID -mean -cut {$ec_rec(t)>0.4};
                       notes -add [subst "$mean(I)\t$mean(E)"]}
}

# Switch off the cell
cell -off
