// This may look like C code, but it is really -*- C++ -*-
// CVS ID : $Id: ECApp.h,v 1.6 2010/08/10 00:46:37 wuthrich Exp $
// ---------------------------------------------------------------- 
//                                                                  
// Header file for  class ECApp
//
// (c) Rolf Wuthrich
//     2010 Concordia University
//
// author:  Rolf Wuthrich
// email:   wuthrich@encs.concordia.ca
// version: v1 ($Revision: 1.6 $)
//
// This software is copyright under the BSD license
//
// ---------------------------------------------------------------
// history:
// ---------------------------------------------------------------
// Date       Modification                     Author
// ---------------------------------------------------------------
// 31.03.2010 Creation                         R. Wuthrich
// 20.06.2010 Added findECProcedure(...)       R. Wuthrich
// ---------------------------------------------------------------

#ifndef ECApp_SEEN_
#define ECApp_SEEN_

#include <tcl.h>
#include <tk.h>
#include "ECRec.h"
#include "ECProcess.h"
#include "ECProcedure.h"
#include "ECEvent.h"

using namespace std;

// -----------------------------------------------------------------------
//
// class ECApp : main application
//

class ECApp
{

  friend void ECTk_eventLoop(ClientData clientData);

protected:

  Tcl_Interp*  interp;

  ECProcess*   FirstECProcess;
  ECRec*       FirstECRecord;
  ECEvent*     event;

  char*        ectk_commentStr;  // generic comment string
  int          output_update;    // output update rate [ms]
                                 // i.e. interval between two calls of
                                 // ECTk_eventLoop
  void sourceRcFile();
  void registerNewCmd();
  void registerGlobalVars();

public:

  ECApp(int argc, char **argv);
  ~ECApp();

  void registerUserCmd();

  ECProcess*   getFirstECProcess();
  void         addECProcess(ECProcess* proc);
  void         removeECProcess(ECProcess* proc);
  ECProcess*   findECProcess(const char* PID);
  ECProcedure* findECProcedure(const char* PID);

  ECRec*       getFirstECRecord();
  void         addECRecord(ECRec* rec, char* recCmd);
  void         removeECRecord(ECRec* rec);
  ECRec*       findECRecord(const char* recID);

  ECEvent* getEvent();

  void run();
};

#endif /* ECApp_SEEN_ */
