// This may look like C code, but it is really -*- C++ -*-
// CVS ID : $Id: ECCell.h,v 1.8 2010/09/07 00:48:05 wuthrich Exp $
// ---------------------------------------------------------------- 
//                                                                  
// Header file for  class ECCellOn
//
// (c) Rolf Wuthrich
//     2010 Concordia University
//
// author:  Rolf Wuthrich
// email:   wuthrich@encs.concordia.ca
// version: v1 ($Revision: 1.8 $)
//
// This software is copyright under the BSD license
//
// ---------------------------------------------------------------
// history:
// ---------------------------------------------------------------
// Date       Modification                     Author
// ---------------------------------------------------------------
// 31.03.2010 Creation                         R. Wuthrich
// ---------------------------------------------------------------

#ifndef ECCell_SEEN_
#define ECCell_SEEN_

#include <tcl.h>
#include "ECEvent.h"
#include "ECProcess.h"

#include <iostream>

using namespace std;


// -----------------------------------------------------------------------
//
// Tcl interface
//

int ECTk_CellCmd(ClientData clientData, Tcl_Interp *interp, 
		 int objc,Tcl_Obj *const objv[]);


// -----------------------------------------------------------------------
//
// class ECCell : class for switching cell on and off
//

class ECCell : public ECProcess
{

protected:

  int cellStatus;    // status of the cell
                     // either CellOn or CellOff

public:

  ECCell(Tcl_Interp *Interp, int CellStatus) :
    ECObj("Cell    ","cell",Interp),
    ECProcess("Cell    ","user","cell",Interp),
    cellStatus(CellStatus)
  {
    verbose=0;
    addOption("-on","defines a cell ON process");
    addOption("-off","defines a cell OFF process");

    if (CellStatus==CellOn)
      {
	name="Cell ON ";
	Tcl_DStringAppend(preProcessScript,"cons \"Turning cell ON\"",-1);
      }
    else
      {
	Tcl_DStringAppend(postProcessScript,"cons \"Turning cell OFF\"",-1);
	name="Cell OFF";
      }
  };

  virtual int  cmd(int &i,int objc,Tcl_Obj *const objv[]);
  virtual void handleEvent(ECEvent* ev);
  virtual Tcl_DString* info(const char* frontStr = "");
};


#endif /* ECCell_SEEN_ */
