// This may look like C code, but it is really -*- C++ -*-
// CVS ID : $Id: ECProcedure.h,v 1.7 2010/08/10 00:46:37 wuthrich Exp $
// ---------------------------------------------------------------- 
//                                                                  
// Header file for  class ECProcedure
//
// (c) Rolf Wuthrich
//     2010 Concordia University
//
// author:  Rolf Wuthrich
// email:   wuthrich@encs.concordia.ca
// version: v1 ($Revision: 1.7 $)
//
// This software is copyright under the BSD license
//
// ---------------------------------------------------------------
// history:
// ---------------------------------------------------------------
// Date       Modification                     Author
// ---------------------------------------------------------------
// 31.03.2010 Creation                         R. Wuthrich
// 20.06.2010 Added ECRec                      R. Wuthrich
// 27.06.2010 Moved ECRec                      R. Wuthrich
// ---------------------------------------------------------------

#ifndef ECProcedure_SEEN_
#define ECProcedure_SEEN_

#include <tcl.h>
#include "ECData.h"
#include "ECProcess.h"

using namespace std;


// -----------------------------------------------------------------------
//
// class ECProcedure : abstract class from which all ECProcedures derive

class ECProcedure : public ECProcess, public ECData
{

protected:

  double dt_aquire; // time interval between two recording of EC data [s]

public:

  ECProcedure(const char *procName, const char* procCmd, Tcl_Interp *Interp);

  virtual int    cmd(int &i,int objc,Tcl_Obj *const objv[]);
  virtual void   handleEvent(ECEvent* ev);
  virtual double potential();

  virtual Tcl_DString* info(const char* frontStr = "");

  virtual int    getNbrECRecords();
};


#endif /* ECProcedure_SEEN_ */
