// This may look like C code, but it is really -*- C++ -*-
// CVS ID : $Id: ECRec.h,v 1.4 2010/08/10 00:46:37 wuthrich Exp $
// ---------------------------------------------------------------- 
//                                                                  
// Header file for  class ECRec
//
// (c) Rolf Wuthrich
//     2010 Concordia University
//
// author:  Rolf Wuthrich
// email:   wuthrich@encs.concordia.ca
// version: v1 ($Revision: 1.4 $)
//
// This software is copyright under the BSD license
//
// ---------------------------------------------------------------
// history:
// ---------------------------------------------------------------
// Date       Modification                     Author
// ---------------------------------------------------------------
// 27.06.2010 Creation                         R. Wuthrich
// ---------------------------------------------------------------

#ifndef ECRec_SEEN_
#define ECRec_SEEN_

#include <tcl.h>
#include "ECData.h"
#include "ECProcedure.h"

using namespace std;

// -----------------------------------------------------------------------
//
// Tcl interface
//

int ECTk_ECRecCmd(ClientData clientData, Tcl_Interp *interp, 
		  int objc,Tcl_Obj *const objv[]);

// -----------------------------------------------------------------------
//
// class ECRec : class able to hold and manipulate EC data

class ECRec : public ECData
{

  friend int ECTk_ECRecCmd(ClientData clientData, Tcl_Interp *interp, 
			   int objc,Tcl_Obj *const objv[]);

protected:

  ECRec* next;

public:

  ECRec(const char* recCmd, Tcl_Interp *Interp) : 
    ECObj("ECRec",recCmd,Interp),
    ECData("ECRec",Interp),
    next(NULL) 
  {
    Tcl_DStringFree(TclCmd);
    Tcl_DStringAppend(TclCmd,recCmd,-1);
  }

  virtual int  cmd(int &i,int objc,Tcl_Obj *const objv[]);
  virtual Tcl_DString* info(const char* frontStr = "");

  ECRec*      getNextECRec() {return next;}
  void        setNextECRec(ECRec* rec) {next=rec;}

  int         loadRecords(const char* fileName,
			  const char* startMark = "", const char* endMark = "");
  int         copyRecords(ECProcedure* ecproc,
			  const char* startMark = "", const char* endMark = "");
};


#endif /* ECRec_SEEN_ */
