// This may look like C code, but it is really -*- C++ -*-
// CVS ID : $Id: ECStep.h,v 1.8 2010/12/05 20:14:48 wuthrich Exp $
// ---------------------------------------------------------------- 
//                                                                  
// Header file for  class ECStep
//
// (c) Rolf Wuthrich
//     2010 Concordia University
//
// author:  Rolf Wuthrich
// email:   wuthrich@encs.concordia.ca
// version: v1 ($Revision: 1.8 $)
//
// This software is copyright under the BSD license
//
// ---------------------------------------------------------------
// history:
// ---------------------------------------------------------------
// Date       Modification                     Author
// ---------------------------------------------------------------
// 17.06.2010 Creation                         R. Wuthrich
// ---------------------------------------------------------------

#ifndef ECStep_SEEN_
#define ECStep_SEEN_

#include <tcl.h>
#include "ECProcedure.h"

using namespace std;


// -----------------------------------------------------------------------
//
// Tcl interface
//

int ECTk_StepCmd(ClientData clientData, Tcl_Interp *interp, 
		 int objc,Tcl_Obj *const objv[]);


// -----------------------------------------------------------------------
//
// class ECStep : holds potential at a fixed value 
//                during a fixed time interval
//

class ECStep : public ECProcedure
{

protected:

  double stepDuration; // duration of step (duration of holding EStep) in sec
  double EStep;        // step potential in V

public:

  ECStep(Tcl_Interp* Interp) :
    ECObj("Step output","step",Interp),
    ECProcedure("Step output","step",Interp),
    stepDuration(0), EStep(0)
  {
    setMarkStr("s");
    addOption("-stepDuration",&stepDuration,"returns/sets duration of step");
    addOption("-stepValue",&EStep,"returns/sets step value");
  }

  virtual void handleEvent(ECEvent* ev);
  virtual double potential();
  virtual Tcl_DString* info(const char* frontStr = "");
};


#endif /* ECStep_SEEN_ */
