// This may look like C code, but it is really -*- C++ -*-
// CVS ID : $Id: ECUserProc.h,v 1.8 2010/09/07 00:48:05 wuthrich Exp $
// ---------------------------------------------------------------- 
//                                                                  
// Header file for  class ECUserProc
//
// (c) Rolf Wuthrich
//     2010 Concordia University
//
// author:  Rolf Wuthrich
// email:   wuthrich@encs.concordia.ca
// version: v1 ($Revision: 1.8 $)
//
// This software is copyright under the BSD license
//
// ---------------------------------------------------------------
// history:
// ---------------------------------------------------------------
// Date       Modification                     Author
// ---------------------------------------------------------------
// 31.03.2010 Creation                         R. Wuthrich
//                                                                  
// ---------------------------------------------------------------

#ifndef ECUserProc_SEEN_
#define ECUserProc_SEEN_

#include <tcl.h>
#include "ECProcedure.h"

using namespace std;


// -----------------------------------------------------------------------
//
// Tcl interface
//

int ECTk_UserProcCmd(ClientData clientData, Tcl_Interp *interp, 
		     int objc,Tcl_Obj *const objv[]);


// -----------------------------------------------------------------------
//
// class ECUserProc : allows user defined ECprocedures
//

class ECUserProc : public ECProcedure
{

protected:

  Tcl_DString* userProcScript;

public:

  ECUserProc(Tcl_Interp *Interp) :
    ECObj("User Procedure","userproc",Interp),
    ECProcedure("User Procedure","userproc",Interp)
  {
    userProcScript = new Tcl_DString;
    Tcl_DStringInit(userProcScript);
    setMarkStr("u");
    addOption("-userScript",userProcScript,"returns/sets user script");
  }

  ~ECUserProc();

  virtual void handleEvent(ECEvent* ev);
  virtual double potential();
  virtual Tcl_DString* info(const char* frontStr = "");

  void         setUserProcScript(Tcl_DString* UserProcScript);
  Tcl_DString* getUserProcScript();
};

#endif /* ECUserProc_SEEN_ */
