# CVS ID : $Id: ectk_install.tcl,v 1.4 2010/08/28 02:02:31 wuthrich Exp $
# ---------------------------------------------------------------
#
# ECTk install facility
#
# (c) Rolf Wuthrich
#     2010 Concordia University
#
# author:  Rolf Wuthrich
# email:   wuthrich@encs.concordia.ca
# version: v1 ($Revision: 1.4 $)
#
# ---------------------------------------------------------------
# history:
# ---------------------------------------------------------------
# Date       Section       Modification             Author
# ---------------------------------------------------------------
# 08.06.10   all           creation                 R. Wuthrich 
# ---------------------------------------------------------------


set share_dir /usr/local/share/ectk
set bin_dir /usr/local/bin
set man_dir /usr/local/share/man

# First makes the needed directory structure

if {[file exists $share_dir]==0} {
    file mkdir $share_dir
}

if {[file exists $man_dir/man1]==0} {
    file mkdir $man_dir/man1
}

if {[file exists $man_dir/man3]==0} {
    file mkdir $man_dir/man3
}

if {[file exists $share_dir/examples]==0} {
    file mkdir $share_dir/examples
}


# copy the various files

file copy -force elchemtkrc $share_dir
file copy -force plot.tcl $share_dir
file copy -force ectk $bin_dir

cd ..
set d [pwd]
foreach f [glob -directory $d/man/man1 *.1ectk] {
    file copy -force $f $man_dir/man1
}

foreach f [glob -directory $d/man/man3 *.3ectk] {
    file copy -force $f $man_dir/man3
}

foreach f [glob -directory $d/examples *.tcl] {
    file copy -force $f $share_dir/examples
}